<?php

namespace gp\controleurs;

use gp\modeles\Game;
use gp\vues\VueGame;
use Slim\Slim;

class ControleurGame
{
    public function getGame($id){
        $route = Slim::getInstance()->request->getResourceUri();
        $game = Game::where('id', '=', $id)->first();
        $results['game'] = $game;
        $results['links'] = [
            "comments" =>["href" => $route."/comments"] ,
            "characters" =>["href" => $route."/characters"],
            "platforms" =>["href" => $route."/platforms"]
        ];
        $v = new VueGame(json_encode($results));
        $v->render('getGame');
    }

    public function getGames(){
        $results = null;
        if(isset($_GET['page'])) {
            $page = filter_var($_GET['page'], FILTER_SANITIZE_NUMBER_INT);
            ini_set('memory_limit', '512M');
            $response = Game::paginate(200, ['*'], 'page', $page);
            $json = (json_decode(json_encode($response), true));
            $route = explode('bdappli_laurent_vonderscher_sassu_percin/GamePedia', Slim::getInstance()->urlFor('getGames'));
            foreach ($json['data'] as $game) {
                $url = $route[1] . "{$game['id']}";
                $results['games'][] = ["game" => $game, "links" => ["self" => ["href" => $url]]];
            }
            $prev = $json['prev_page_url'];
            $next = $json['next_page_url'];
            if ($next == '') $next = $json['first_page_url'];
            if ($prev == '') $prev = $json['last_page_url'];
            $links = ["prev" => ["href" => "/api/games{$prev}"], "next" => ["href" => "/api/games{$next}"]];
            $results['links'] = $links;
        }
        $v = new VueGame(json_encode($results));
        $v->render('getGames');
    }

    public function getGameComments($id){
        $game = Game::where('id', '=', $id)->first();
        $comments = $game->comments()->get();
        $v = new VueGame(json_encode($comments));
        $v->render('getComments');
    }

    public function getGamePlatforms($id){
        $game = Game::where('id', '=', $id)->first();
        $platforms = $game->platforms()->get();
        $route = explode('bdappli_laurent_vonderscher_sassu_percin/GamePedia',Slim::getInstance()->urlFor('getPlatforms'));
        foreach ($platforms as $platform) {
            $url = $route[1]."{$platform['id']}";
            $results['platforms'][] = ["platform" => $platform, "links" => ["self" => ["href" => $url]]];
        }
        $v = new VueGame(json_encode($results));
        $v->render('getPlatforms');
    }

    public function getGameCharacters($id){
        $game = Game::where('id', '=', $id)->first();
        $characters = $game->characters()->get();
        $route = explode('bdappli_laurent_vonderscher_sassu_percin/GamePedia',Slim::getInstance()->urlFor('getCharacters'));
        foreach ($characters as $character) {
            $url = $route[1]."{$character['id']}";
            $results['characters'][] = ["character" => $character, "links" => ["self" => ["href" => $url]]];
        }
        $v = new VueGame(json_encode($results));
        $v->render('getPlatforms');
    }
}